function [trace] = logn_trace(cv, N, alpha, time_end)

x = 1; % Number of requests for less popular content
lambda = (1./(1:N).^alpha);
lambda = x.*lambda.*(N^alpha);
lambda = lambda./sum(lambda);
Ti = 1./lambda;

v=(cv.*Ti).^2;
expected = sum(ceil(lambda*time_end*1.2+1));
mu = log(Ti.^2./sqrt(v+Ti.^2));
sigma = sqrt(log((v./Ti.^2)+1));
trace = zeros(round(expected*4), 2);

idx=1;

for i=1:N
    i;
    if (mod(i,1000)==0)
        clc
        disp(['Generating Trace...', num2str(round(100*i/N)), '%'])
    end

    d=[];
    while(sum(d) < time_end)
        d = [d; lognrnd(mu(i), sigma(i), ceil(lambda(i)*time_end*2),1)]; 
    end

    % first generation residual life
    rl = lognrnd(mu(i), sigma(i),1000,1);
    trl=cumsum(rl);
    rand_attival=rand*trl(end);
    idrl=find(trl>rand_attival,1,'first');
    first_arrrival_time=trl(idrl)-rand_attival;
    d = [first_arrrival_time; d];
    t = cumsum(d);
    trace(idx:idx+length(t)-1,:)=[t i*ones(length(t),1)];
    idx=idx+length(t);
end

trace = trace((trace(:,2)~=0),:);
trace = sortrows(trace,1);

end
