function [trace] = exp_trace(N, alpha, time_end)

x = 1; % Number of requests for less popular content
lambda = (1./(1:N).^alpha);
lambda = x.*lambda.*(N^alpha);
lambda = lambda./sum(lambda);
Ti = 1./lambda;

expected = mean(lambda).*time_end.*N;
trace = zeros(round(expected*1.5), 2);
idx=1;

for i=1:N
    if (mod(i,1000)==0)
        clc
        disp(['Generating Trace...', num2str(round(100*i/N)), '%'])
    end
    d = -Ti(i) * log(rand(ceil(lambda(i)*time_end*1.2),1));
    t = cumsum([rand()*Ti(i); d]);
    trace(idx:idx+length(t)-1,:)=[t i*ones(length(t),1)];
    idx=idx+length(t);
end

trace = trace((trace(:,2)~=0),:);
trace = sortrows(trace,1);

end


